# Demo_1
class Link:

	empty = ()
	def __init__(self, first, rest=empty):
		assert rest is Link.empty or isinstance(rest, Link)
		self.first = first
		self.rest = rest
	# test 
	# link = Link(1, Link(2, Link(3))) 
	# second = link.rest
	# third = second.rest
	# link.first, second.first, third.rest is Link.empty
	# link2 = Link(0, link)
	# link2.rest is link
	# link3 = Link(link, link2)

# Demo_2
def sum_link(link):
	"""Returns the sum of the elements in the list"""
	if link is Link.empty:
		return 0
	return link.first + sum_link(link.rest)

# Demo_3
def display_link(link):
	"""Display a string representation of the input linked list link"""
	str_num = ''
	while link is not Link.empty:
		str_num += ' ' + str(link.first)
		link = link.rest #link is just a pointer to the linked list Link(1,xxx)
	return '<'+ str_num + ' >'

# Link(Link(1), Link(2, Link(3)))
def display_nested_link(link):
	"""Display a string representation of the input linked list link, including the nested list"""
	str_num = ''
	while link is not Link.empty:
		if isinstance(link.first, Link):
			elem = display_nested_link(link.first)
		else:
			elem = str(link.first)	
		str_num += elem + ' '
		link = link.rest 
	return '< '+ str_num + '>'

# Demo_4
# display_link(map_link(lambda x: x * x, Link(1,Link(2,Link(3)))))
# may let students think how to do this using iteration rather than recursion
# not easy to keep order of the list when using iteration: how to point to a list that has not been created yet?
def map_link(f, link):
	if link is not Link.empty:
		return Link(f(link.first), map_link(f, link.rest))
	else:
		return Link.empty


# diaplay_nested_link(map_nested_link(lambda x: x * x, Link(Link(1,Link(2)),Link(3,Link(4)))))
def map_nested_link(f, link):
	if link is not Link.empty:
		if isinstance(link.first, Link):# consider nested link
			elem = map_link(f, link.first)
		else:
			elem = f(link.first)
	else:
		return Link.empty 
	return Link(elem, map_link(f,link.rest))

# Demo_5
# Mutating Linked List
# link = Link(1,Link(2,Link(3)))
# link.first = 996
# link2 = link
# link2.rest.first = 998
# display_link(link)
# link.rest = Link(4) modify
# link.rest = link.rest.rest remove

