# Demo_1
# Tree class
class Tree:
	def __init__(self, label, branches=[]):
		for b in branches:
			assert isinstance(b, Tree)
		self.label = label
		self.branches = list(branches)

	def is_leaf(self):
		return not branches

def print_tree(t, indent=0):
	print(' ' * indent, t.label)
	for b in t.branches:
		print_tree(b, indent + 1)

# Demo_2
# print_tree(t)
# map(lambda x: x*x, t)		
# print_tree(t)
def map(f, t):
	t.label = f(t.label)
	for b in t.branches:
		map(f, b)

t = Tree(1,[Tree(2,[Tree(5,[Tree(7)]),Tree(6)]),Tree(3),Tree(4)])

t2 = Tree(1,[Tree(2,[Tree(1,[Tree(7)]),Tree(6)]),Tree(1),Tree(4)])

# Demo_3
# print_tree(t2)
# prune(t2,1)
# print_tree(t2)
def prune(t, n):
	"""prune all sub-trees whose label is n"""
	t.branches = [b for b in t.branches if b.label 	!= n]
	for b in t.branches:
		prune(b, n)


